﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd">
    <head>
        <link href="../Resources/TableStyles/Default-Table.css" rel="stylesheet" MadCap:stylesheetType="table" /><title>Creating Analytics Control (V1) using SQL Query</title>
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" type="text/css" />
    </head>
    <body>
        <h1>Creating Analytics Control (V1) using SQL Query</h1>
        <p>You can create an analytics control using SQL Query to retrieve&#160;relevant information from the database. This is one of the most powerful features in&#160;analytics configurations since it allows you to retrieve information directly from the database. The results generated by this analytic control configuration are stored in the database for future reference.</p>
        <p>To create a new analytics control (V1) using SQL Query, perform the following steps:</p>
        <ol>
            <li>
                <p>Select  &#160;<strong>Analytics &gt; Analytics Configuration List</strong>.</p>
            </li>
            <li>
                <p>Select the Version 1 tab for creating non-elastic analytics control.</p>
            </li>
            <li>
                <p>Click <strong>Create New Analytics</strong>.</p>
            </li>
            <li>
                <p>Select Using SQL Query,&#160;click Create. The Create New Analytics Configuration page is displayed.</p>
            </li>
        </ol>
        <p class="note">
            <div class="confluence-information-macro-body">
                <p>Before creating the analytics control, there is an option to <strong>Preview</strong> the control configuration, towards the end of the <strong>Create New Analytics Configuration </strong>page.</p>
                <p>Note the following points related to <strong>Preview</strong> and <strong>Create</strong> buttons:</p>
                <ul>
                    <li>If the SQL query that you entered in the control configuration, returns more than or equal to ten records, then the analytics preview displays all the ten records. If the query returns less than ten records, the preview displays those many numbers of records.</li>
                    <li>The <strong>Preview</strong> button is enabled before you click the<strong> Create</strong> button. Once the analytics control is created, you cannot view the <strong>Preview</strong> button.</li>
                    <li>The <strong>Preview</strong> button is used to validate the correctness of the query syntax and to display the first 10 rows of the result data. This does not validate columns in the analytics query for the allowed action. An error message is displayed if the query syntax is incorrect. You can view the error details from the log files or by executing the same query directly in the database.</li>
                    <li>The <strong>Create</strong> button must be used as the final step in the creation of the analytics control. This validates the mandatory columns in the analytics query for the allowed action. You will be able to select the visible and filterable columns for the control and submit the control creation only if all validations are complete.</li>
                </ul>
            </div>
        </p>
        <p>The following table provides information about the fields in&#160;<strong>Create New Analytics Configuration </strong>page.</p>
        <div class="table-wrap">
            <table class="TableStyle-Default-Table" style="width: 100%;mc-table-style: url('../Resources/TableStyles/Default-Table.css');" cellspacing="0">
                <col style="width: 18.7434%;" class="TableStyle-Default-Table-Column-Column1" />
                <col style="width: 81.1216%;" class="TableStyle-Default-Table-Column-Column1" />
                <thead>
                    <tr class="TableStyle-Default-Table-Head-Header1">
                        <th class="TableStyle-Default-Table-HeadE-Column1-Header1">Parameter</th>
                        <th class="TableStyle-Default-Table-HeadD-Column1-Header1">Description</th>
                    </tr>
                </thead>
                <tbody>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Analytics Name<span style="color: rgb(255,0,0);">*</span></p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p style="text-align: left;" class="table-text">Enter the appropriate analytics name.</p>
                            <p style="text-align: left;" class="table-text">This is a free-text-entry field. The analytics name must be unique and the system does not allow you to create multiple analytics with the same name.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Analytics Query</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <div class="content-wrapper">
                                <p>Enter the analytics query in SQL, depending on the scenario for which the report is created.</p>
                                <p><strong>Example1:&#160;</strong>
                                </p>
                                <MadCap:codeSnippet>
                                    <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                    <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                                    <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select USERNAME from USERS limit 5;</MadCap:codeSnippetBody>
                                </MadCap:codeSnippet>
                                <p><strong>Example 2:&#160;</strong>
                                </p>
                                <MadCap:codeSnippet>
                                    <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                    <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                                    <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select ac.NAME FROM accounts ac;</MadCap:codeSnippetBody>
                                </MadCap:codeSnippet>
                                <p><strong>Example 3:</strong>
                                </p>
                                <MadCap:codeSnippet>
                                    <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                    <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                                    <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select username,firstname,lastname from users where city='${city}' limit 100;</MadCap:codeSnippetBody>
                                </MadCap:codeSnippet>
                                <p>(In the above example, a dynamic attribute is used in the query.)</p>
                                <p><strong>Example 4:&#160;</strong>
                                </p>
                                <MadCap:codeSnippet>
                                    <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                    <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                                    <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select username as 'username', firstname as 'ep',lastname as 'et', middlename from users limit 20;&#160;</MadCap:codeSnippetBody>
                                </MadCap:codeSnippet>
                                <p><strong>Example 5:&#160;</strong>
                                </p>
                                <MadCap:codeSnippet>
                                    <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                    <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                                    <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">SELECT ev.ENTITLEMENT_VALUE, ev.UPDATEDATE, ev.CUSTOMPROPERTY1 as Id FROM entitlement_values ev INNER JOIN entitlement_types et ON ev.ENTITLEMENTTYPEKEY = et.ENTITLEMENTTYPEKEY INNER JOIN endpoints ep ON et.ENDPOINTKEY = ep.ENDPOINTKEY INNER JOIN securitysystems ss ON ep.SECURITYSYSTEMKEY = ss.SYSTEMKEY INNER JOIN externalconnection excon ON ss.EXTERNALCONNECTION = excon.EXTERNALCONNECTIONKEY INNER JOIN externalconnectiontype conType ON excon.EXTERNALCONNECTIONTYPE = conType.EXTERNALCONNECTIONTYPEKEY WHERE conType.CONNECTIONTYPE = 'Salesforce' AND et.ENTITLEMENTNAME = 'Profile' AND ev.STATUS = 1   </MadCap:codeSnippetBody>
                                </MadCap:codeSnippet>
                                <div class="confluence-information-macro confluence-information-macro-note conf-macro output-block">
                                    <div class="confluence-information-macro-body">
                                        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                                            <p class="note">As few columns are displayed twice because of the query and option to select the column, the following columns have been restricted for Non-ES to be passed.</p>
                                            <ul>
                                                <li>
                                                    <p class="note">status column</p>
                                                </li>
                                                <li>
                                                    <p class="note">comments column</p>
                                                </li>
                                            </ul>
                                        </div>
                                        <p>As a workaround, you can still pass status and column by specifying an alias for status or column in the query, which will still create and run the control. It displays only one column as desired for status and column. The following examples explain this point.</p>
                                        <p>Example 1:</p>
                                        <p>In the above example, accountstatus is an alias used to fetch status. You can use any other alias other than status.</p>
                                        <p><span style="color: rgb(0,0,0);">Example 2:</span>
                                        </p>
                                        <MadCap:codeSnippet>
                                            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                            <MadCap:codeSnippetCaption>SQL</MadCap:codeSnippetCaption>
                                            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: SQL;">select comments as acccomments from accounts;                                         </MadCap:codeSnippetBody>
                                        </MadCap:codeSnippet>
                                        <p>In the above example, acccomments is an alias used to fetch the value of the comments. You can use an alias other than comments.&#160;</p>
                                    </div>
                                </div>
                            </div>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Description</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <div class="content-wrapper">
                                <p>Description for the analytic query.</p>
                                <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                                    <p class="note">By default, IGA supports only 255 characters in the Description field.</p>
                                    <p class="note">In case you want more than 255 characters in this field, change the description dataType to longText in the database table.</p>
                                </div>
                            </div>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Category</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <div class="content-wrapper">
                                <p>The category into which the new analytic belongs to:</p>
                                <ul>
                                    <li><strong>Access Request System -&#160; </strong>analytic belonging to ARS.</li>
                                    <li><strong>Preventive SOD check - </strong>analytic is for preventive SOD check.</li>
                                    <li><strong>Information Refresh -&#160;</strong>analytic is for looking for stale information or refreshing the information.</li>
                                    <li><strong>Non-Person Accounts - </strong>analytic is for checking the non-person accounts.</li>
                                    <li><strong>Usage -</strong> analytic is for understanding the usage.</li>
                                    <li><strong>Provisioning - </strong>analytic for keeping track of provisioning.</li>
                                    <li><strong>De Provisioning -&#160;</strong>analytic for keeping track of de-provisioning.</li>
                                    <li><strong>Certification -&#160;</strong>analytic for keeping track of certifications.</li>
                                    <li><strong>Create New -&#160;</strong>allows you to create a new category.</li>
                                </ul>
                                <p>To create a new category:</p>
                                <ol>
                                    <li>In the <strong>Category</strong> drop down, click <strong>Create New</strong>. The Create New Category window is displayed.</li>
                                    <li>In the <strong>Category Name</strong> box, specify a name for the category and click <strong>Create</strong>.</li>
                                </ol>
                                <p>You cannot create a category containing underscore.</p>
                                <p>
                                    <img src="../Resources/Images/create new category.png" style="width: 314px;height: 248px;border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                                </p>
                            </div>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Sub Category</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <div class="content-wrapper">
                                <p>Inside a category, you can further divide the analytical controls under subcategories.&#160;You can either choose an existing subcategory or create and add new subcategories.&#160;</p>
                                <p>You can create a new subcategory using the <strong>Create New</strong> option in the dropdown list. When you click on this option, the following pop-up window appears. Enter the subcategory name and click <strong>Create</strong>, to create the new subcategory.</p>
                                <p>
                                    <img src="../Resources/Images/create new sub category.png" style="width: 338px;height: 243px;border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                                </p>
                                <p>Figure: Creating New SubCategory for Analytics Control</p>
                            </div>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">External Connection</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Name of the Connector, for which the report is being created.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Status</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Status of&#160;the selected&#160;pre-configured query.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Owner</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">You can add owner for the selected&#160;pre-configured query.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Application</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Select the endpoint/application, for which the analytic is created.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Update User</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Describes the user name initiating the analytic query.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Update Date</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Describes the user name initiating the analytic query.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Risk<span style="color: rgb(255,0,0);">*</span></p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the level of risk involved in creating the analytic, possible values are:</p>
                            <ul>
                                <li><strong>Low</strong> - involves less risk</li>
                                <li><strong>Medium</strong> - medium risk involved</li>
                                <li><strong>High</strong> - high risk involved</li>
                            </ul>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Tags</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Unique labels to easily segregate the reports.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Email Template</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">The Email template being used, to send out an analytic report to the user.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Number of History to Keep</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <div class="content-wrapper">
                                <p style="text-align: left;">Enter the number of entries to be stored in the history for analysis in numerical format.</p>
                                <p style="text-align: left;">For example, if the 'Number of History to Keep' count is 5, then on 6th run, run history details of the very first run will be deleted from IGA.The value that you enter in the <strong>Number of History to Keep</strong> field should always be greater than or equal to Base Count.</p>
                            </div>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Enable Archival</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Select this option if the number of history to keep is more than 0. If selected, then the&#160;&#160;older control result will be archived in the archival folder before deleting it.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Recommendations</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Recommendations (if any) for the analytic created.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">Base Count</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Displaying all the records each time continuously would be an overhead for IGA. Using Base count feature, you can specify the count from when the number of records to be displayed is a delta or difference between the number of records available before the run and records newly added after the run.</p>
                            <p class="table-text">To understand this, lets take an example:</p>
                            <p class="table-text">Base count is set to 3 for following example use case.</p>
                            <ul>
                                <li>First run - &gt; number of records fetched is 10. Hence, base set is set to 10 records.<ul><li>New records are added after first run : 2 records added</li></ul></li>
                                <li>Second run - &gt; number of records to be shown will be 2, which is delta from current run (12) - previous run base set (10) = 2<ul><li>New records are added after second run : 5 records added</li></ul></li>
                                <li>Third run - &gt; number of records to be shown will be 5, which is delta from current run (17) - previous run base set (12) = 5</li>
                                <li>Now, as per the Base Count configured which is 3 in this example, the base set is set to 17 after 3 runs.<ul><li>Before the fourth run, 3 more records are added.</li></ul></li>
                                <li>Fourth run - &gt; number of records to be shown will be 3, which is delta from current run (20) - previous run base set (17) = 3&#160;</li>
                            </ul>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyB-Column1-Body1">
                            <p class="table-text">Allowed Action</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyA-Column1-Body1">
                            <div class="content-wrapper">
                                <p>If you want to make a report as actionable, you can pre-select the actions that need to be taken on records displayed in the control report. For more information, see&#160;Allowed Actions Table in&#160;<MadCap:xref href="Creating-Actionable-Analytic-Report.htm">Creating Actionable Analytic Report</MadCap:xref> .</p>
                                <p>
                                    <img src="../Resources/Images/Action options from  the Analytics History Detail of an Analytics Control.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                                </p>
                                <p>Figure: Action options from&#160; the Analytics History Detail of an Analytics Control</p>
                            </div>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <ol MadCap:continue="true">
            <li>Enter the parameters in the table,&#160;click <strong>Create.&#160;</strong></li>
            <li>When you click <strong>Create </strong>or <strong>Update</strong> after entering all the required parameter details, an additional pop-up screen appears. You can check or clear the check boxes&#160;to be displayed or to be filtered in the report. </li>
            <li>Depending on the SQL query, you can select the columns and type of fields to be displayed. Click <strong>Submit</strong>.</li>
            <li>For creating a similar analytic report from an existing Analytic Configuration. Click <strong>Create Similar Analytics</strong></li>
            <li>
                <p>After the analytics is created, you can run the analytic using the following options available under <strong>Run.</strong></p>
                <ol>
                    <li>Dry Run - The newly created/edited analytics will be run on a test basis, but the results are not stored in the run history</li>
                    <li>Run Now -&#160;The newly created/edited analytics will be run and the results are stored under run history</li>
                    <li>Run History - Displays the previously run analytics history and results from multiple runs can be compared</li>
                </ol>
            </li>
            <li>The analytics history can be viewed from <strong>History</strong>&#160;tab.</li>
            <li>You can also delete an existing analytic from the screen. Click <strong>Delete.</strong></li>
        </ol>
    </body>
</html>